﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private Sql1 As SQL
	Private Rs As  ResultSet
	Private strSql As String
End Sub

Public Sub sql_IsInitialized As Boolean
	Return Sql1.IsInitialized
End Sub

Public Sub InitSql
	Sql1.InitializeSQLite(File.DirApp, "Solitaire.db", True)
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Cards (Id INTEGER PRIMARY KEY, Card BLOB)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Undo (Seq INTEGER PRIMARY KEY DESC, From_Col INTEGER, To_Col INTEGER, Qtde INTEGER)")
End Sub

Public Sub insert_Image(id As Int, im As Image)
	strSql="INSERT INTO Cards VALUES(" & id & ",  " & Null & ")"
	Sql1.ExecNonQuery(strSql)	
	Dim Out As OutputStream
	Dim Buffer() As Byte
	Out.InitializeToBytesArray(10000)
	im.WriteToStream(Out)
	Buffer = Out.ToBytesArray
	Out.Close 
	strSql="UPDATE Cards SET Card = ? WHERE (Id = " & id  & ")"
	Sql1.ExecNonQuery2(strSql, Array As Object(Buffer))
End Sub

Public Sub Clear_Undo
	Sql1.ExecNonQuery("DELETE FROM Undo")
End Sub

Public Sub Save_Undo(From_Col As Short, To_Col As Short, Qtde As Short)
	Dim Seq As Int
	strSql = "Select Max(Seq) as Sq From Undo Order by Seq desc limit 1"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Seq = Rs.GetInt("Sq") + 1
	End If
	Rs.Close
	strSql="INSERT INTO Undo VALUES(" & Seq & ", " & From_Col & ", " & To_Col & ", " & Qtde & ")"
	Sql1.ExecNonQuery(strSql)	
End Sub

Public Sub Execute_Undo As Int()
	Dim Seq As Int
	Dim Ret(3) As Int
	strSql = "Select Max(Seq) as Sq From Undo Order by Seq desc limit 1"
	Rs = Sql1.ExecQuery(strSql)
	Seq = Rs.GetInt("Sq") 
	If Seq = 0 Then
		Ret(0) = -1
		Ret(1) = -1
		Ret(2) = -1
		Rs.Close
		Return Ret
	End If
	Rs.Close
	strSql = "Select * From Undo WHERE (Seq = " & Seq  & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Ret(0) = Rs.GetInt("From_Col")
		Ret(1) = Rs.GetInt("To_Col")
		Ret(2) = Rs.GetInt("Qtde")
		Sql1.ExecNonQuery("DELETE FROM Undo WHERE (Seq = " & Seq  & ")")
	End If
	Rs.Close
	Return Ret
End Sub

Public Sub Get_Image(id As Int) As Image
	Dim Buffer() As Byte 
	Dim InpStr As InputStream
	Dim tmpImg As Image 
	strSql = "Select Card From Cards WHERE(Id = " & id & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Buffer = Rs.GetBlob("Card")
		InpStr.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
		tmpImg.Initialize2(InpStr)
		InpStr.Close
	End If
	Return tmpImg
End Sub

Public Sub Close_Sql
	Sql1.close
End Sub