﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private fTurnCard As Form
	Private imgToTurn As ImageView
	Private imgIdx As Short
	Private tm As Timer
	Private stpH As Double
	Private imgWdt, imgHgt, Rot As Double
	Private Ulx, Uly, Urx, Ury, Lrx, Lry, Llx, Lly As Double 
	Private pEffect As JavaObject 
	Private Undo As Boolean
End Sub

Public Sub Initialize(fr As Form)
	fTurnCard.Initialize("",10, 10)
	fTurnCard.SetFormStyle("TRANSPARENT")
	fTurnCard.BackColor = fx.Colors.Transparent
	fTurnCard.WindowLeft = -20
	fTurnCard.SetOwner(fr)
	tm.Initialize("tm",20)
	tm.Enabled = False
End Sub

Public Sub Img_to_Turn(imgV As ImageView, idx As Short, cUndo As Boolean)
	imgToTurn = imgV
	imgIdx = idx
	Undo = cUndo
	If Undo Then
		stpH = 1
	Else
		stpH = -1
	End If
	Rot = 4
	imgHgt = imgToTurn.Height
	imgWdt = imgToTurn.Width 
	Dim pEffect As JavaObject
	pEffect.InitializeNewInstance("javafx.scene.effect.PerspectiveTransform", Null) 
	Ulx = 0: Uly = 0
	Urx = imgWdt: Ury = 0
	Llx = 0: Lly = imgHgt
	Lrx = imgWdt: Lry =  imgHgt
	Set_Effect
	Dim imjo As JavaObject
	imjo = imgToTurn
	imjo.RunMethod("setCache", Array(True))
	imjo.RunMethod("setEffect", Array(pEffect))
	tm.Enabled = True
	'fTurnCard.ShowAndWait
End Sub

private Sub Turn_Card
	If Ulx >imgWdt/2 Then
		Dim EfTmp As Double
		If Undo Then
			imgToTurn.SetImage(DbManager.Get_Image(304))
		Else
			imgToTurn.SetImage(DbManager.Get_Image(imgIdx))
		End If
		EfTmp = Ury
		Ury = Uly
		Uly = EfTmp
		EfTmp = Lry
		Lry = Lly
		Lly = EfTmp
		imgWdt = 99999999
		Rot = Rot * -1
	End If
	Ulx = Ulx + Rot: Uly = Uly - stpH 
	Urx = Urx - Rot: Ury = Ury + stpH
	Llx = Llx + Rot: Lly = Lly + stpH 
	Lrx = Lrx - Rot: Lry = Lry - stpH 
	Set_Effect
	If Ulx < = 0  Then
		Ulx = 0: Uly = 0
		Urx = imgToTurn.Width: Ury = 0
		Llx = 0: Lly = imgToTurn.Height
		Lrx = imgToTurn.Width: Lry =  imgToTurn.Height 
		Set_Effect
		Main.SoundPlay
		fTurnCard.Close
	Else
		tm.Enabled = True
	End If		
End Sub

Private Sub tm_tick
	tm.Enabled = False
	Turn_Card
End Sub


private Sub Set_Effect
	pEffect.RunMethod("setUlx", Array(Ulx))
	pEffect.RunMethod("setUly", Array(Uly))
	pEffect.RunMethod("setUrx", Array(Urx))
	pEffect.RunMethod("setUry", Array(Ury))
	pEffect.RunMethod("setLrx", Array(Lrx))
	pEffect.RunMethod("setLry", Array(Lry))
	pEffect.RunMethod("setLlx", Array(Llx))
	pEffect.RunMethod("setLly", Array(Lly))
End Sub	